package gui;

import java.util.Comparator;
import java.util.Map;

/**
 * This class is used to rank the rankings section of the scoreboard.
 *
 * @author Michael Gebauer
 */
public class ScoreboardComparator implements Comparator<Map.Entry<Team,Double>> {

  /**
   * Compares two objects as specified by the Comparator.compare method.
   *
   * @param o1 - must be a Map.Entry&lt;Team,Double&gt;
   * @param o2 - must be a Map.Entry&lt;Team,Double&gt;
   * @return
   */
  public int compare(Map.Entry<Team,Double> entry1, Map.Entry<Team,Double> entry2) {
    Team key1 = entry1.getKey();
    Double value1 = entry1.getValue();
    Team key2 = entry2.getKey();
    Double value2 = entry2.getValue();

    // perform the comparison
    // compare scores first
    int compared = value2.compareTo(value1);
    // if scores are the same them sort by team order
    if (compared == 0)
      compared = key1.compareTo(key2);
    return compared;
  }

}

//  LocalWords:  param
