package gui;

import static gui.GameFlowModel.DEFAULT_QUESTION_TIME;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;

public class TimerPanel extends JPanel {

  static final long serialVersionUID = 20060219L;
  public static final int WARN_WHEN_SECONDS = 10;

  private JLabel timerText = new JLabel(String.valueOf(DEFAULT_QUESTION_TIME), JLabel.CENTER);
  private JButton nextButton, pauseButton, addTimeButton, removeTimeButton;
  public final String next = "Advance";
  public final String pause = "Pause";
  public final String addTime = "Add 10s";
  public final String removeTime = "Remove 10s";

  public TimerPanel() {
    setBorder(new LineBorder(Color.BLACK, 2));
    setBackground(Color.WHITE);
    BoxLayout layout = new BoxLayout(this, BoxLayout.Y_AXIS);
    setLayout(layout);

    timerText.setFont(new Font(null, Font.BOLD, 60));
    timerText.setPreferredSize(new Dimension(80,90));
    add(timerText);

    nextButton = new JButton(next);
    nextButton.setBackground(Color.WHITE);
    add(nextButton);

    pauseButton = new JButton(pause);
    pauseButton.setBackground(Color.WHITE);
    add(pauseButton);

    addTimeButton = new JButton(addTime);
    addTimeButton.setBackground(Color.WHITE);
    add(addTimeButton);

    removeTimeButton = new JButton(removeTime);
    removeTimeButton.setBackground(Color.WHITE);
    add(removeTimeButton);
  }

  public void addButtonListener(ActionListener listener) {
    nextButton.addActionListener(listener);
    pauseButton.addActionListener(listener);
    addTimeButton.addActionListener(listener);
    removeTimeButton.addActionListener(listener);
  }

  public void setTime(int time) {
    String timeString = String.valueOf(time);
    timerText.setText(timeString);
    if (time <= WARN_WHEN_SECONDS) {
      timerText.setForeground(Color.RED);
    } else {
      timerText.setForeground(Color.BLACK);
    }
  }
}
